/* inport.c -- An other example of low-level io from userspace                                   */


#include <stdio.h>

#include <asm/types.h>   /* headers for architecture specific data types                         */
#include <unistd.h>      /* contains the prototype for i386 specific ioperm functioni            */
#include <asm/io.h>      /* obviously architecture specific (asm directory) for inb, outb macros */

#define LP_BASE 0x379

int main(void) {

	int portdata;

	/* attempt to reserve region in io space */
	if(ioperm(0x220, 4, 1) < 0) {
		fprintf(stderr, "Cannot reserve region in io space, aborting...\n");
		exit(1);
	}

	//	/* send data byte to io port */
	//	portdata = inb(LP_BASE);
	outb(0x34,0x223);
	while (1) {
	  scanf("%d",&portdata);
	  outb(portdata & 0xFF,0x220);
	  outb(portdata >> 8 & 0xFF,0x220);

	}

	/* attempt to release reserved region in io space */
	if(ioperm(0x220, 4, 0) < 0) {
		fprintf(stderr, "Cannot release region in io space, aborting...\n");
		exit(1);
	}

	return(0);  /* just to be nice ;) */

}
