#include <stdio.h>
#include <stdlib.h>

#include "qcam.h"
#include "qcam_gfx.h"

void main (void) {
	scanbuf *buf;
	struct qcam *q;

	q = qc_init ();		/* set built in defaults, init qcam pointer */
	qc_initfile (q, NULL);	/* read defaults from file */
	
	if (qc_open (q)) {	/* locking QCAM device */
		fprintf (stderr, "An error occured opening QCAM.\n");
		exit (-1);
	}

	qc_set (q);		/* reset, set SendFrameMode, init QCAM */
	buf = qc_scan (q);	/* get a frame from QCam */

	switch (qc_getversion (q)) {
		case COLOR_QUICKCAM:
			buf = qc_scale (buf, 3, qc_getwidth(q)/qc_gettransfer_scale(q), qc_getheight(q)/qc_gettransfer_scale(q), qc_getwidth(q), qc_getheight(q));
			qc_writeppm (q, stdout, buf);
			break;

		case BW_QUICKCAM:
			qc_writepgm (q, stdout, buf);
			break;
	}


	free (buf);		/* release memory */
	qc_close (q);		/* clear locks */
}
